/*
 ============================================================================
 Name        : DataLogger.c
 Author      : Sandra Nägele
 Version     :
 Copyright   : SWE Übung 3
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define LEN 20


struct adres {
               char vname[LEN];
               char nname[LEN];
               int  geburtsjahr;
            };
            typedef struct adres TADRESS;


// Optionen Anzeige
void help(void){
	printf("adressen [Option] File Option Beschreibung");
	 printf("\n-h Gibt eine kurze Beschreibung der Optionen aus.");
	 printf("\n-p Alle Adressen sollen ausgegeben werden.");
	 printf("\n-s Alle Adressen sollen sortiert nach Namen ausgegeben werden.");
	 printf("\n-f Sortiert alle Adressen nach Namen und suche nach muster");

}


// Einlesen
TADRESS* einlesen(char *filename, int *anzahl){
	TADRESS*Daten;
	int temp[4];
	FILE*fp;
	fp=fopen(filename,"w");
	if(fp==NULL){
		printf("Datei konnte nicht geöffnet werden!\n");
		return -1;
	}
	else{
		fscanf("%d",anzahl);
		Daten=calloc(anzahl,sizeof(TADRESS));
		for(int i=1;i==EOF;i++){
			fscanf(filename, "%s",Daten[i].vname);
			fscanf(filename,"%s",Daten[i].nname);
			fscanf(filename,"%s",temp[4]);
			Daten[i].geburtsjahr=atoi(temp);
		}

return Daten;
	}

}

// Ausgabe in File
void ausgabe(TADRESS* p, int anzahl, FILE *fp){
	p=einlesen(filename,anzahl);
	for(int i=0;i==EOF;i++){
		printf("Vorname: %s\nNachname: %s\nGeburtsjahr: %s\n",p[i].vname,p[i].nname,p[i].geburtsjahr);
	}
}

//Compare Funktion
int comp(const void *a, const void *b){
	int cmp;
	TADRESS*one= (TADRESS*) a;
	TADRESS*two= (TADRESS*) b;
	cmp=strcmp(one->nname,two->nname);
	return cmp;
}

// Sortiert alle Adressen nach Namen.
void sort_name(TADRESS* p, int anzahl){
	p=einlesen(filename,anzahl);
	qsort(p,anzahl,sizeof(TADRESS),comp);

	for(int i=0;i==EOF;i++){
		printf("Vorname: %s\nNachname: %s\nGeburtsjahr: %s\n",p[i].vname,p[i].nname,p[i].geburtsjahr);
	}


}

// Sortiert alle Adressen nach Namen und durchsuche diese.
void suche_name(TADRESS* p, int anzahl, char *name){
	int Vorname, Nachname;
	p= einlesen(filename,anzahl);
	//strcmp liefert 0 wenn strings gleich
	for(int i=0;i==EOF;i++){
	Vorname=strcmp(p[i].vname,name);
	Nachname=strcmp(p[i].nname,name);
	if(Vorname==0 && Nachname ==0){
		printf("Muster (gleiche Vor- und Nachamen) gefunden :\n");
		printf("Vorname: %s\nNachname: %s\nGeburtsjahr:%d",p[i].vname,p[i].nname,p[i].geburtsjahr);
	}
}

}


int main(int argc, char* argv[]) {
	TADRESS*p;
	int anzahl;
	char*name;
	FILE*fp;
	char*filename;

	for (int i = 1; i < argc; i++)
	    {
	        if (strcmp(argv[i],"-h")==0)
	        {
	            help();
	            return 0;
	        }
	        else if (strcmp(argv[i],"-p")==0)
	        {
	            if (i+2>argc)
	            {
	                printf("Fehler!\n");
	                help();
	                return -1;
	            }
	            else
	            {
	            	ausgabe(p,anzahl,fp);
	            }
	        }
	        else if (strcmp(argv[i],"-s")==0)
	        {
	            if (i + 2 > argc)
	            {
	                printf("Fehler!\n");
	                help();
	                return -1;
	            }
	            else
	            {
	               sort_name(p,anzahl);
	            }
	        }
	        else if(strcmp(argv[i],"-f")==0)
	        {
	            if (i + 2 > argc)
	            {
	                printf("Fehler!\n");
	                help();
	                return -1;
	            }
	            else
	            {
	               suche_name(p,anzahl,name);
	            }

	    }

	 }
	return EXIT_SUCCESS;
}
